; File:     PrintIt.inc
; 
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           
                
                cmp     eax, WM_CREATE
                je      _WM_CREATE
                cmp     eax, WM_PAINT
                je      _WM_PAINT

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                              
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret

; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE:     invoke CreateFont, 70, 0, 0, 0, FW_BOLD, 0, 0, 0,
                                   DEFAULT_CHARSET, OUT_TT_PRECIS,
                                   CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
                                   DEFAULT_PITCH or FF_DONTCARE,
                                   ADDR _FontCourierNew
                mov     _hFont0, eax
                
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_PAINT
; -----------------------------------------------------------------
_WM_PAINT:      ;invoke  BeginPaint, _hWnd, ADDR _ps

                invoke  GetClientRect, _hWnd, ADDR _rc

                invoke  SelectObject, _hdc, _hFont0
                mov     _oFont0, eax

                invoke  SetBkMode, _hdc, TRANSPARENT
                invoke  SetTextColor, _hdc, 0ffffffh

                ;-------------------------------------------
                ; Draw the text on a single line, centering
                ;     it horizontally and vertically
                ;-------------------------------------------
                invoke  DrawText, _hdc, ADDR _sPrintIt, -1, ADDR _rc,
                                  DT_SINGLELINE or DT_CENTER or DT_VCENTER

                invoke SelectObject, _hdc, _oFont0

                ;invoke EndPaint, _hWnd, ADDR _ps


                jmp       _EndProcA
                ;jmp       _ExitProcA        ; doesnt work properly !!!
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     cmp     _hpdc, 0
                je      short @F
                ;
                invoke   DeleteDC, _hpdc
                ;
@@:             invoke    GlobalFree, _pTxtMem
                invoke    GlobalFree, _pFrmMem
                
                call      FileClose
                invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
;------------------------------------------------------------------------------------------------------------------****
; Aco:
;           converte a dword Val para DECIMAL e coloca na string RCL apontada
;           por pRcl. Termina a string com 0 e anula a string se o buffer
;           for insuficiente
;
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
CnvToRcl    proc    Val:DWORD, pRcl:DWORD
            push    ebx
            push    esi
            push    edi

            mov     eax, [esp+16]           ; Val
            mov     edi, [esp+20]           ; pBuf

            test    eax, eax
            jnz     short @F
            
            mov     dword ptr [edi - 4], 1
            mov     word ptr [edi], 30h
            mov     byte ptr [edi + 1], 0        ; terminate the string
            clc
            jnc     _exit

@@:
            mov     ecx, 3435973837
            xor     esi, esi
                        
@@:             mov     ebx, eax
                mul     ecx
                shr     edx, 3
                mov     eax, edx
                lea     edx, [edx*4+edx]
                add     edx, edx
                sub     ebx, edx
                add     bl, '0'
                ;
                push    ebx                 ; To stack
                add     esi, 1
            or      eax, eax
            jnz     short @B
            
            ; Buffer length control 
            cmp     esi, dword ptr [edi - 8]
            jbe     short _go
            ;
@@:         pop     eax                     ; Get from stack
            sub     esi, 1
            jnz     short @B            
            
            mov     dword ptr [edi - 4], 0
            mov     byte ptr [edi], 0           ; terminate the string            
            stc
            jc      short _exit
            ;
            
_go:        mov     dword ptr [edi - 4], esi
                         
@@:         pop     eax                     ; Get from stack
            mov     byte ptr [edi], al
            add     edi, 1
            sub     esi, 1
            jnz     short @B            

            mov     byte ptr [edi], 0           ; terminate the string
            clc
            
_exit:      pop     edi
            pop     esi
            pop     ebx
            ret     8
CnvToRcl    endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclCpy       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx- 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                ;
                cmp     ecx, dword ptr [edx - 8]
                jbe     short @F

                mov     ecx, dword ptr [edx - 8]
                ;
@@:             mov     dword ptr [edx - 4], ecx
                cmp     ecx, 0
                jne     short @F
                
                ret     8
                ;               
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B
                
                ret     8
RclRclCpy       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
RclRclAdd       proc    pRcl1:DWORD, pRcl2:DWORD

                mov     ebx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [ebx - 4]
                ;
                mov     edx, [esp + 8]              ; pRcl2
                mov     eax, dword ptr [edx - 4]                
                add     ecx, eax
                ;
                cmp     ecx, dword ptr [edx - 8]
                jbe     short @F
                ;
                ret     8
                ;             
@@:             mov     dword ptr [edx - 4], ecx
                ;
                add     edx, eax
                mov     ecx, dword ptr [ebx - 4]                
                ;
@@:             sub     ecx, 1
                movzx   eax, byte ptr [ebx + ecx] 
                mov     byte ptr [edx + ecx], al
                jnz     short @B

                ret     8
RclRclAdd       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Add Char in AL
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
BarRclAdd       proc    pRcl1:DWORD

                mov     edx, [esp + 4]              ; pRcl1
                mov     ecx, dword ptr [edx - 4]                
                add     ecx, 1
                ;
                cmp     ecx, dword ptr [edx - 8]
                jbe     short @F
                ;
                ret     4
                
@@:             mov     dword ptr [edx - 4], ecx
                mov     byte ptr [edx + ecx], "/"

                ret     4
BarRclAdd       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
ByteToHex   proc    Val:DWORD, pRcl:DWORD

            mov     edx, [esp + 8]
            mov     ebx, [esp + 4]

            mov     ecx, 1
            and     ebx, 0FFh
            
@@:         mov     eax, ebx            ; we're going to work on AL
            and     al, 00001111b       ; mask out high nibble

            cmp     al, 10    
            sbb     al, 69h
            das

            mov     [edx + ecx], al     ; store the asciihex(AL) in the string
            shr     ebx, 4              ; next nibble            
            dec     ecx                 ; decrease counter (one byte less than dec cl :-)
            jns     short @B

            mov     byte ptr [edx + 2], "h"
            mov     byte ptr [edx + 3], 0            
            mov     dword ptr [edx - 4], 3
            ret     8
ByteToHex   endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Allocate moveable memory
;
; Output:
;           EDI     - ponteiro
;           EBX     - memory handle
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
MemoAlloc       proc        Bytes:DWORD
                ;
                mov         eax, [esp + 4]          ; Bytes
                add         eax, 4
                ;
                invoke      GlobalAlloc, GMEM_MOVEABLE, eax
                cmp         eax, NULL
                jne         short @F

                fn  MessageBox, _hWnd, "GlobalAlloc error","Error", MB_OK
                stc
                ret         4
                ;
@@:             mov         ebx, eax                ; ebx = handle
                invoke      GlobalLock, ebx
                cmp         eax, NULL
                jne         short @F

                fn  MessageBox, _hWnd, "GlobalLock error","Error", MB_OK
                stc
                ret         4
                ;
@@:             mov         edi, eax                ; edi - pointer
                invoke      GlobalUnlock, ebx
                cmp         eax, FALSE
                je          short @F
                ;
                ; erro: still locked
                ;
                fn  MessageBox, _hWnd, "GlobalUnlock error","Error", MB_OK
                stc
                ret         4
@@:             call        GetLastError
                cmp         eax, NO_ERROR
                je          short @F
                ;
                ; erro: still locked
                ;
                fn  MessageBox, _hWnd, "GlobalUnlock error stil locked","Error", MB_OK                
                stc    
                ret         4
                ; is unlocked
@@:             clc
                ret         4
MemoAlloc       endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Output:
;           EAX     - ponteiro memoria
;           EDI     - ponteiro Rcl
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
AlocRclMem      proc        Bytes:DWORD
                ;
                mov         eax, [esp + 4]          ; Bytes
                mov         ebx, eax
                add         eax, 10
                ;
                invoke      GlobalAlloc, GMEM_FIXED, eax
                cmp         eax, NULL
                jne         short @F

                stc
                ret         4
                ;
@@:             mov         edi, eax
                add         edi, 8
                ;
                mov         dword ptr [edi - 8], ebx
                mov         dword ptr [edi - 4], 0
                mov         dword ptr [edi + ebx], 0    ; null terminator
                clc
                ret         4
AlocRclMem      endp
;OPTION PROLOGUE:PrologueDef
;OPTION EPILOGUE:EpilogueDef
; 
; Output:
;           EAX     - ponteiro
;
;OPTION PROLOGUE:NONE
;OPTION EPILOGUE:NONE
AllocMemo       proc        Bytes:DWORD        
                ;
                mov         eax, [esp + 4]          ; Bytes
                mov         ebx, eax
                ;
                invoke      GlobalAlloc, GMEM_FIXED, eax
                cmp         eax, NULL
                jne         short @F

                stc
                ret         4
                ;
@@:             sub         ebx, 1
                mov         dword ptr [eax + 0], ebx
                mov         dword ptr [eax + 4], 0
                mov         dword ptr [eax + ebx], 0    ; null terminator
                clc
                ret         4
AllocMemo       endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
GetPosPrn           proc    Lin:DWORD, Col:DWORD

                    invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmHeight
                    mov     eax, [esp + 4]                  ;Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmAveCharWidth
                    mov     eax, [esp + 8]                  ;Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax
                    ret     8
GetPosPrn           endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
; Input:
;       pRcl    - points to a RCL string that have this format:
;
;                           dd ?        <- max length  at  address of _name -8
;                           dd ?        <- length      at  address of _name -4
;                   _Name   db ????????
;
;
; left justified
;
TextPrintL          proc    pRcl:DWORD, Lin:DWORD, Col:DWORD

                    mov     ebx, pRcl
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    invoke  TextOut, _hpdc, _PosPrnX, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
TextPrintL          endp
; 
; Input:
;       pRcl    - points to a RCL string that have this format:
;
;                           dd ?        <- max length  at  address of _name -8
;                           dd ?        <- length      at  address of _name -4
;                   _Name   db ????????
;
; right justified
;
TextPrintR          proc    pRcl:DWORD, Lin:DWORD, Col:DWORD

                    mov     ebx, pRcl
                    cmp     dword ptr [ebx - 4], 0
                    jne     short @F
                    clc
                    ret
                    
@@:                 invoke  GetTextMetrics, _hpdc, addr _tm
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmHeight
                    mov     eax, Lin
                    sub     eax, 1
                    mul     ecx                 
                    mov     _PosPrnY, eax
                    ;
                    ;
                    ;
                    mov     ecx, _tm.TEXTMETRIC.tmAveCharWidth
                    mov     eax, Col
                    sub     eax, 1
                    mul     ecx
                    mov     _PosPrnX, eax

                    invoke  GetTextExtentPoint32, _hpdc, ebx, [ebx - 4], addr _WidthStrPrn
                    mov     eax, _PosPrnX
                    sub     eax, _WidthStrPrn
                
                    invoke  TextOut, _hpdc, eax, _PosPrnY, ebx, [ebx - 4]
                    clc
                    ret
TextPrintR          endp
; 
SendTest3       proc
                pushfd
                pushad  
                ;
                mov     esi, _pFrmBuf                   
                mov     eax, dword ptr [esi - EndRegLst]

                invoke  ShowNumber, eax

                cmp     eax, 0
                je      short _exit
                ;
                sub     eax, 1
                mul     dword ptr [esi - LenRegLst]
                add     esi, eax
                ;
                mov     edi, offset _TestBuf
                
                mov     ecx, dword ptr [esi - 4]
                mov     byte ptr [edi + ecx], 0    
                
                cmp     ecx, 0
                je      short _n
                ;                              
@@:             sub     ecx, 1
                movzx   eax, byte ptr [esi + ecx]
                mov     byte ptr [edi + ecx], al
                jnz     short @B

_n:             fn  MessageBox, _hWnd, offset _TestBuf, "Test 3", MB_OK 	
                ;
_exit:          popad
                popfd
                ret
SendTest3       endp
; 
Test1           proc
pushfd
pushad
fn  MessageBox, _hWnd, "Teste 1","Test1", MB_OK
popad
popfd
ret
Test1           endp
; 
ShowNumber      proc  Val:DWORD
                pushfd
                pushad
                
                invoke  CnvToRcl, Val, addr _RclBuffer
                fn      MessageBox, _hWnd, addr _RclBuffer,"Test5", MB_OK

                popad
                popfd
                ret
ShowNumber      endp
; 
ShowHexa        proc  Val:DWORD
                pushfd
                pushad

                invoke  ByteToHex, Val, addr _RclBuffer
                fn      MessageBox, _hWnd, addr _RclBuffer,"Test6", MB_OK

                popad
                popfd
                ret
ShowHexa        endp
; ##############################################################################################

